## mingw-w64-blender-4.5.2-3.src.tar.zst

=== extern/bullet2/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Foundation
#
# SPDX-License-Identifier: GPL-2.0-or-later

# avoid noisy warnings
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  remove_cc_flag(
    "-Wall"
  )
endif()

# Use double precision to make simulations of small objects stable.
add_definitions(-DBT_USE_DOUBLE_PRECISION)

set(INC
  .
  src
)

set(INC_SYS

)

set(SRC
  src/BulletCollision/BroadphaseCollision/btAxisSweep3.cpp
  src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.cpp
  src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.cpp
  src/BulletCollision/BroadphaseCollision/btDbvt.cpp
  src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.cpp
  src/BulletCollision/BroadphaseCollision/btDispatcher.cpp
  src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.cpp
  src/BulletCollision/BroadphaseCollision/btQuantizedBvh.cpp
  src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.cpp
  src/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp
  src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp
  src/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp
  src/BulletCollision/CollisionDispatch/btCollisionObject.cpp
  src/BulletCollision/CollisionDispatch/btCollisionWorld.cpp
  src/BulletCollision/CollisionDispatch/btCollisionWorldImporter.cpp
  src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btCompoundCompoundCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.cpp
  src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btGhostObject.cpp
  src/BulletCollision/CollisionDispatch/btHashedSimplePairCache.cpp
  src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.cpp
  src/BulletCollision/CollisionDispatch/btManifoldResult.cpp
  src/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp
  src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.cpp
  src/BulletCollision/CollisionDispatch/btUnionFind.cpp
  src/BulletCollision/CollisionShapes/btBox2dShape.cpp
  src/BulletCollision/CollisionShapes/btBoxShape.cpp
  src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.cpp
  src/BulletCollision/CollisionShapes/btCapsuleShape.cpp
  src/BulletCollision/CollisionShapes/btCollisionShape.cpp
  src/BulletCollision/CollisionShapes/btCompoundShape.cpp
  src/BulletCollision/CollisionShapes/btConcaveShape.cpp
  src/BulletCollision/CollisionShapes/btConeShape.cpp
  src/BulletCollision/CollisionShapes/btConvex2dShape.cpp
  src/BulletCollision/CollisionShapes/btConvexHullShape.cpp
  src/BulletCollision/CollisionShapes/btConvexInternalShape.cpp
  src/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp
  src/BulletCollision/CollisionShapes/btConvexPolyhedron.cpp
  src/BulletCollision/CollisionShapes/btConvexShape.cpp
  src/BulletCollision/CollisionShapes/btConvexTriangleMeshShape.cpp
  src/BulletCollision/CollisionShapes/btCylinderShape.cpp
  src/BulletCollision/CollisionShapes/btEmptyShape.cpp
  src/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp
  src/BulletCollision/CollisionShapes/btMiniSDF.cpp
  src/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp
  src/BulletCollision/CollisionShapes/btMultiSphereShape.cpp
  src/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.cpp
  src/BulletCollision/CollisionShapes/btOptimizedBvh.cpp
  src/BulletCollision/CollisionShapes/btPolyhedralConvexShape.cpp
  src/BulletCollision/CollisionShapes/btScaledBvhTriangleMeshShape.cpp
  src/BulletCollision/CollisionShapes/btSdfCollisionShape.cpp
  src/BulletCollision/CollisionShapes/btShapeHull.cpp
  src/BulletCollision/CollisionShapes/btSphereShape.cpp
  src/BulletCollision/CollisionShapes/btStaticPlaneShape.cpp
  src/BulletCollision/CollisionShapes/btStridingMeshInterface.cpp
  src/BulletCollision/CollisionShapes/btTetrahedronShape.cpp
  src/BulletCollision/CollisionShapes/btTriangleBuffer.cpp
  src/BulletCollision/CollisionShapes/btTriangleCallback.cpp
  src/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp
  src/BulletCollision/CollisionShapes/btTriangleIndexVertexMaterialArray.cpp
  src/BulletCollision/CollisionShapes/btTriangleMesh.cpp
  src/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp
  src/BulletCollision/CollisionShapes/btUniformScalingShape.cpp
  src/BulletCollision/Gimpact/btContactProcessing.cpp
  src/BulletCollision/Gimpact/btGImpactBvh.cpp
  src/BulletCollision/Gimpact/btGImpactCollisionAlgorithm.cpp
  src/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp
  src/BulletCollision/Gimpact/btGImpactShape.cpp
  src/BulletCollision/Gimpact/btGenericPoolAllocator.cpp
  src/BulletCollision/Gimpact/btTriangleShapeEx.cpp
  src/BulletCollision/Gimpact/gim_box_set.cpp
  src/BulletCollision/Gimpact/gim_contact.cpp
  src/BulletCollision/Gimpact/gim_memory.cpp
  src/BulletCollision/Gimpact/gim_tri_collision.cpp
  src/BulletCollision/NarrowPhaseCollision/btContinuousConvexCollision.cpp
  src/BulletCollision/NarrowPhaseCollision/btConvexCast.cpp
  src/BulletCollision/NarrowPhaseCollision/btGjkConvexCast.cpp
  src/BulletCollision/NarrowPhaseCollision/btGjkEpa2.cpp
  src/BulletCollision/NarrowPhaseCollision/btGjkEpaPenetrationDepthSolver.cpp
  src/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp
  src/BulletCollision/NarrowPhaseCollision/btMinkowskiPenetrationDepthSolver.cpp
  src/BulletCollision/NarrowPhaseCollision/btPersistentManifold.cpp
  src/BulletCollision/NarrowPhaseCollision/btPolyhedralContactClipping.cpp
  src/BulletCollision/NarrowPhaseCollision/btRaycastCallback.cpp
  src/BulletCollision/NarrowPhaseCollision/btSubSimplexConvexCast.cpp
  src/BulletCollision/NarrowPhaseCollision/btVoronoiSimplexSolver.cpp

  src/BulletDynamics/Character/btKinematicCharacterController.cpp
  src/BulletDynamics/ConstraintSolver/btConeTwistConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btContactConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btFixedConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btGearConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btGeneric6DofConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btGeneric6DofSpring2Constraint.cpp
  src/BulletDynamics/ConstraintSolver/btGeneric6DofSpringConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btHinge2Constraint.cpp
  src/BulletDynamics/ConstraintSolver/btHingeConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btNNCGConstraintSolver.cpp
  src/BulletDynamics/ConstraintSolver/btPoint2PointConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btSequentialImpulseConstraintSolver.cpp
  src/BulletDynamics/ConstraintSolver/btSliderConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btSolve2LinearConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btTypedConstraint.cpp
  src/BulletDynamics/ConstraintSolver/btUniversalConstraint.cpp
  src/BulletDynamics/Dynamics/btDiscreteDynamicsWorld.cpp
  src/BulletDynamics/Dynamics/btRigidBody.cpp
  src/BulletDynamics/Dynamics/btSimpleDynamicsWorld.cpp
  src/BulletDynamics/Featherstone/btMultiBody.cpp
  src/BulletDynamics/Featherstone/btMultiBodyConstraint.cpp
  src/BulletDynamics/Featherstone/btMultiBodyConstraintSolver.cpp
  src/BulletDynamics/Featherstone/btMultiBodyDynamicsWorld.cpp
  src/BulletDynamics/Featherstone/btMultiBodyJointLimitConstraint.cpp
  src/BulletDynamics/Featherstone/btMultiBodyJointMotor.cpp
  src/BulletDynamics/Featherstone/btMultiBodyPoint2Point.cpp
  src/BulletDynamics/MLCPSolvers/btDantzigLCP.cpp
  src/BulletDynamics/MLCPSolvers/btLemkeAlgorithm.cpp
  src/BulletDynamics/MLCPSolvers/btMLCPSolver.cpp
  src/BulletDynamics/Vehicle/btRaycastVehicle.cpp
  src/BulletDynamics/Vehicle/btWheelInfo.cpp

  src/BulletSoftBody/btDefaultSoftBodySolver.cpp
  src/BulletSoftBody/btSoftBody.cpp
  src/BulletSoftBody/btSoftBodyConcaveCollisionAlgorithm.cpp
  src/BulletSoftBody/btSoftBodyHelpers.cpp
  src/BulletSoftBody/btSoftBodyRigidBodyCollisionConfiguration.cpp
  src/BulletSoftBody/btSoftRigidCollisionAlgorithm.cpp
  src/BulletSoftBody/btSoftRigidDynamicsWorld.cpp
  src/BulletSoftBody/btSoftSoftCollisionAlgorithm.cpp

  src/LinearMath/btAlignedAllocator.cpp
  src/LinearMath/btConvexHull.cpp
  src/LinearMath/btConvexHullComputer.cpp
  src/LinearMath/btGeometryUtil.cpp
  src/LinearMath/btPolarDecomposition.cpp
  src/LinearMath/btQuickprof.cpp
  src/LinearMath/btSerializer.cpp
  src/LinearMath/btSerializer64.cpp
  src/LinearMath/btVector3.cpp

  src/BulletCollision/BroadphaseCollision/btAxisSweep3.h
  src/BulletCollision/BroadphaseCollision/btBroadphaseInterface.h
  src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.h
  src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.h
  src/BulletCollision/BroadphaseCollision/btDbvt.h
  src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.h
  src/BulletCollision/BroadphaseCollision/btDispatcher.h
  src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.h
  src/BulletCollision/BroadphaseCollision/btOverlappingPairCallback.h
  src/BulletCollision/BroadphaseCollision/btQuantizedBvh.h
  src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h
  src/BulletCollision/CollisionDispatch/SphereTriangleDetector.h
  src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btBoxBoxDetector.h
  src/BulletCollision/CollisionDispatch/btCollisionConfiguration.h
  src/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h
  src/BulletCollision/CollisionDispatch/btCollisionDispatcher.h
  src/BulletCollision/CollisionDispatch/btCollisionObject.h
  src/BulletCollision/CollisionDispatch/btCollisionObjectWrapper.h
  src/BulletCollision/CollisionDispatch/btCollisionWorld.h
  src/BulletCollision/CollisionDispatch/btCollisionWorldImporter.h
  src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btCompoundCompoundCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.h
  src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.h
  src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.h
  src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btGhostObject.h
  src/BulletCollision/CollisionDispatch/btHashedSimplePairCache.h
  src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.h
  src/BulletCollision/CollisionDispatch/btManifoldResult.h
  src/BulletCollision/CollisionDispatch/btSimulationIslandManager.h
  src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.h
  src/BulletCollision/CollisionDispatch/btUnionFind.h
  src/BulletCollision/CollisionShapes/btBox2dShape.h
  src/BulletCollision/CollisionShapes/btBoxShape.h
  src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.h

=== extern/vulkan_memory_allocator/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Blender Foundation
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
)

set(INC_SYS
  ${VULKAN_INCLUDE_DIRS}
)

if(APPLE)
  list(APPEND INC_SYS
    ${MOLTENVK_INCLUDE_DIRS}
  )
endif()

set(SRC
  vk_mem_alloc_impl.cc

  vk_mem_alloc.h
)

set(LIB
)

blender_add_lib(extern_vulkan_memory_allocator "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  target_compile_options(extern_vulkan_memory_allocator
    PRIVATE "-Wno-nullability-completeness"
  )
endif()

=== intern/ghost/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  PUBLIC .
  ../guardedalloc
)

set(INC_SYS
)

set(SRC
  intern/GHOST_Buttons.cc
  intern/GHOST_C-api.cc
  intern/GHOST_CallbackEventConsumer.cc
  intern/GHOST_Context.cc
  intern/GHOST_ContextNone.cc
  intern/GHOST_EventManager.cc
  intern/GHOST_ISystem.cc
  intern/GHOST_ISystemPaths.cc
  intern/GHOST_ModifierKeys.cc
  intern/GHOST_Path-api.cc
  intern/GHOST_PathUtils.cc
  intern/GHOST_Rect.cc
  intern/GHOST_System.cc
  intern/GHOST_TimerManager.cc
  intern/GHOST_Window.cc
  intern/GHOST_WindowManager.cc

  GHOST_C-api.h
  GHOST_IContext.hh
  GHOST_IEvent.hh
  GHOST_IEventConsumer.hh
  GHOST_ISystem.hh
  GHOST_ISystemPaths.hh
  GHOST_ITimerTask.hh
  GHOST_IWindow.hh
  GHOST_Path-api.hh
  GHOST_Rect.hh
  GHOST_Types.h

  intern/GHOST_Buttons.hh
  intern/GHOST_CallbackEventConsumer.hh
  intern/GHOST_Context.hh
  intern/GHOST_ContextNone.hh
  intern/GHOST_Debug.hh
  intern/GHOST_Event.hh
  intern/GHOST_EventButton.hh
  intern/GHOST_EventCursor.hh
  intern/GHOST_EventDragnDrop.hh
  intern/GHOST_EventKey.hh
  intern/GHOST_EventManager.hh
  intern/GHOST_EventString.hh
  intern/GHOST_EventTrackpad.hh
  intern/GHOST_EventWheel.hh
  intern/GHOST_ModifierKeys.hh
  intern/GHOST_PathUtils.hh
  intern/GHOST_System.hh
  intern/GHOST_SystemPaths.hh
  intern/GHOST_TimerManager.hh
  intern/GHOST_TimerTask.hh
  intern/GHOST_Util.hh
  intern/GHOST_Window.hh
  intern/GHOST_WindowManager.hh
  intern/GHOST_utildefines.hh
  intern/GHOST_utildefines_variadic.hh
)

set(LIB
  PRIVATE bf::blenlib
  PRIVATE bf::dna
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::intern::clog
)

if(WITH_INPUT_IME)
  add_definitions(-DWITH_INPUT_IME)
endif()

if(WITH_OPENGL_BACKEND)
  list(APPEND INC_SYS
    ${Epoxy_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${Epoxy_LIBRARIES}
  )
  add_definitions(-DWITH_OPENGL_BACKEND)
endif()

if(WITH_VULKAN_BACKEND)
  if(WITH_VULKAN_MOLTENVK)
    list(APPEND INC_SYS
      PUBLIC ${MOLTENVK_INCLUDE_DIRS}
    )

    list(APPEND LIB
      ${MOLTENVK_LIBRARIES}
    )
  endif()

  list(APPEND SRC
    intern/GHOST_ContextVK.cc

    intern/GHOST_ContextVK.hh
  )
  list(APPEND INC
    ../../extern/vulkan_memory_allocator/
  )
  list(APPEND INC_SYS
    PUBLIC ${VULKAN_INCLUDE_DIRS}
  )

  list(APPEND LIB
    ${VULKAN_LIBRARIES}
  )

  add_definitions(-DWITH_VULKAN_BACKEND)
endif()

if(WITH_GHOST_DEBUG)
  list(APPEND SRC
    intern/GHOST_EventPrinter.cc

    intern/GHOST_EventPrinter.hh
  )
  add_definitions(-DWITH_GHOST_DEBUG)
endif()

if(WITH_INPUT_NDOF)
  add_definitions(-DWITH_INPUT_NDOF)

  list(APPEND SRC
    intern/GHOST_NDOFManager.cc

    intern/GHOST_EventNDOF.hh
    intern/GHOST_NDOFManager.hh
  )

  # Only some platforms define this.
  if(DEFINED NDOF_INCLUDE_DIRS)
    list(APPEND INC_SYS
      ${NDOF_INCLUDE_DIRS}
    )
  endif()
  if(DEFINED NDOF_LIBRARIES)
    list(APPEND LIB
      ${NDOF_LIBRARIES}
    )
  endif()
endif()

list(APPEND SRC
  intern/GHOST_SystemHeadless.hh
  intern/GHOST_WindowNULL.hh
)

if(WITH_HEADLESS)
  add_definitions(-DWITH_HEADLESS)
elseif(WITH_GHOST_SDL)
  list(APPEND SRC
    intern/GHOST_ContextSDL.cc
    intern/GHOST_SystemSDL.cc
    intern/GHOST_WindowSDL.cc

    intern/GHOST_ContextSDL.hh
    intern/GHOST_SystemSDL.hh
    intern/GHOST_WindowSDL.hh
  )
  add_definitions(-DWITH_GHOST_SDL)

  list(APPEND INC_SYS
    ${SDL_INCLUDE_DIR}
  )
  list(APPEND LIB
    ${SDL_LIBRARY}
  )
elseif(APPLE AND NOT WITH_GHOST_X11)
  list(APPEND SRC
    intern/GHOST_SystemCocoa.mm
    intern/GHOST_WindowCocoa.mm

    intern/GHOST_SystemCocoa.hh
    intern/GHOST_WindowCocoa.hh
    intern/GHOST_WindowViewCocoa.hh
  )

  if(WITH_INPUT_NDOF)
    list(APPEND SRC
      intern/GHOST_NDOFManagerCocoa.mm

      intern/GHOST_NDOFManagerCocoa.hh
    )
  endif()

elseif(WITH_GHOST_X11 OR WITH_GHOST_WAYLAND)
  if(WITH_GHOST_X11)
    list(APPEND INC_SYS
      ${X11_X11_INCLUDE_PATH}
    )

    list(APPEND LIB
      ${X11_X11_LIB}
      ${X11_Xrender_LIB}
    )

    list(APPEND SRC
      intern/GHOST_SystemX11.cc
      intern/GHOST_WindowX11.cc

      intern/GHOST_IconX11.hh
      intern/GHOST_SystemX11.hh
      intern/GHOST_WindowX11.hh
    )

    if(WITH_OPENGL_BACKEND)
      list(APPEND SRC
        intern/GHOST_ContextGLX.cc

        intern/GHOST_ContextGLX.hh
      )
    endif()

    if(WITH_GHOST_XDND)
      add_definitions(-DWITH_XDND)

      list(APPEND LIB
        extern_xdnd
      )

      list(APPEND INC
        ../../extern/xdnd
      )

      list(APPEND SRC
        intern/GHOST_DropTargetX11.cc

        intern/GHOST_DropTargetX11.hh
      )
    endif()

    if(X11_XF86keysym_INCLUDE_PATH)
      add_definitions(-DWITH_XF86KEYSYM)
      list(APPEND INC_SYS
        ${X11_XF86keysym_INCLUDE_PATH}
      )
    endif()

    if(WITH_X11_XFIXES)
      add_definitions(-DWITH_X11_XFIXES)
      list(APPEND INC_SYS
        ${X11_Xfixes_INCLUDE_PATH}
      )
      list(APPEND LIB
        ${X11_Xfixes_LIB}
      )
    endif()

    if(WITH_X11_XINPUT)
      add_definitions(-DWITH_X11_XINPUT)
      list(APPEND INC_SYS
        ${X11_Xinput_INCLUDE_PATH}
      )
      list(APPEND LIB
        ${X11_Xinput_LIB}
      )
    endif()

    add_definitions(-DWITH_GHOST_X11)
  endif()

  if(WITH_GHOST_WAYLAND)
    list(APPEND INC_SYS
      ${wayland-client_INCLUDE_DIRS}
      ${wayland-egl_INCLUDE_DIRS}
      ${xkbcommon_INCLUDE_DIRS}
      ${wayland-cursor_INCLUDE_DIRS}
    )
    list(APPEND LIB
      ${xkbcommon_LINK_LIBRARIES}
    )

    if(WITH_GHOST_WAYLAND_DYNLOAD)
      list(APPEND INC_SYS
        ../wayland_dynload/extern
      )
      list(APPEND LIB
        bf_intern_wayland_dynload
      )
      add_definitions(-DWITH_GHOST_WAYLAND_DYNLOAD)
    else()
      list(APPEND LIB
        ${wayland-client_LINK_LIBRARIES}
        ${wayland-egl_LINK_LIBRARIES}
        ${wayland-cursor_LINK_LIBRARIES}
      )
    endif()

    if(WITH_GHOST_WAYLAND_LIBDECOR)
      list(APPEND INC_SYS
        ${libdecor_INCLUDE_DIRS}
      )
      if(NOT WITH_GHOST_WAYLAND_DYNLOAD)
        list(APPEND LIB
          ${libdecor_LIBRARIES}
        )
      endif()
    endif()

    include(CheckSymbolExists)
    set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE")
    check_symbol_exists(memfd_create "sys/mman.h" HAVE_MEMFD_CREATE)
    unset(CMAKE_REQUIRED_DEFINITIONS)
    if(HAVE_MEMFD_CREATE)
      add_definitions(-DHAVE_MEMFD_CREATE)
    endif()

    check_symbol_exists(poll "poll.h" HAVE_POLL)
    if(HAVE_POLL)
      add_definitions(-DHAVE_POLL)
    endif()

    if(WITH_GHOST_WAYLAND_LIBDECOR)
      # See code-comment for `USE_LIBDECOR_CONFIG_COPY_WORKAROUND`.
      check_symbol_exists(malloc_usable_size "malloc.h" HAVE_MALLOC_USABLE_SIZE)
      if(HAVE_MALLOC_USABLE_SIZE)
        add_definitions(-DHAVE_MALLOC_USABLE_SIZE)
      endif()
    endif()

    list(APPEND SRC
      intern/GHOST_SystemWayland.cc
      intern/GHOST_WindowWayland.cc

      intern/GHOST_SystemWayland.hh
      intern/GHOST_WaylandUtils.hh
      intern/GHOST_WindowWayland.hh
    )

    set(INC_DST ${CMAKE_CURRENT_BINARY_DIR}/libwayland)

    # Generate protocols bindings.
    macro(generate_protocol_bindings PROT_DEF)
      # File name without directory or extension (use for header name).
      get_filename_component(_name ${PROT_DEF} NAME_WLE)
      add_custom_command(
        OUTPUT ${INC_DST}/${_name}-client-protocol.h
        COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DST}
        COMMAND ${WAYLAND_SCANNER} client-header ${PROT_DEF} ${INC_DST}/${_name}-client-protocol.h
      )
      add_custom_command(
        OUTPUT ${INC_DST}/${_name}-client-protocol.c
        COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DST}
        COMMAND ${WAYLAND_SCANNER} private-code ${PROT_DEF} ${INC_DST}/${_name}-client-protocol.c
        DEPENDS ${INC_DST}/${_name}-client-protocol.h
      )

      if(CMAKE_C_COMPILER_ID MATCHES "Clang")
        # Prevent warnings/failure to compile with generated `WL_PRIVATE` declarations.
        set_source_files_properties(
          "${INC_DST}/${_name}-client-protocol.c"
          PROPERTIES COMPILE_FLAGS "-Wno-missing-variable-declarations"
        )
      endif()

      list(APPEND SRC
        ${INC_DST}/${_name}-client-protocol.c
        ${INC_DST}/${_name}-client-protocol.h
      )
      unset(_name)
    endmacro()

    list(APPEND INC_SYS
      ${INC_DST}
    )

    # Used when: LIBDECOR is not needed.
    # `xdg-shell`.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/stable/xdg-shell/xdg-shell.xml"
    )
    # `xdg-decoration`.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/xdg-decoration/xdg-decoration-unstable-v1.xml"
    )
    # End LIBDECOR alternative.

    # `xdg-output`.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/xdg-output/xdg-output-unstable-v1.xml"
    )
    # `xdg-activation`.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/staging/xdg-activation/xdg-activation-v1.xml"
    )
    # Fractional scale.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/staging/fractional-scale/fractional-scale-v1.xml"
    )
    # Viewport (only required when fractional scale is in use).
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/stable/viewporter/viewporter.xml"
    )
    # Pointer-constraints.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/pointer-constraints/pointer-constraints-unstable-v1.xml"
    )
    # Relative-pointer.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/relative-pointer/relative-pointer-unstable-v1.xml"
    )
    # Pointer-gestures (multi-touch).
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/pointer-gestures/pointer-gestures-unstable-v1.xml"
    )
    # Tablet.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/stable/tablet/tablet-v2.xml"
    )
    # Primary-selection.
    generate_protocol_bindings(
      "${WAYLAND_PROTOCOLS_DIR}/unstable/primary-selection/primary-selection-unstable-v1.xml"
    )
    if(WITH_INPUT_IME)
      generate_protocol_bindings(
        "${WAYLAND_PROTOCOLS_DIR}/unstable/text-input/text-input-unstable-v3.xml"
      )
    endif()

    unset(INC_DST)

    add_definitions(-DWITH_GHOST_WAYLAND)
    if(NOT WITH_GHOST_WAYLAND_APP_ID STREQUAL "")
      add_definitions(-DWITH_GHOST_WAYLAND_APP_ID=${WITH_GHOST_WAYLAND_APP_ID})
    endif()

  endif()

  if(WITH_INPUT_NDOF)
    list(APPEND SRC
      intern/GHOST_NDOFManagerUnix.cc

      intern/GHOST_NDOFManagerUnix.hh
    )
  endif()

  if(NOT WITH_INSTALL_PORTABLE)
    add_definitions(-DPREFIX="${CMAKE_INSTALL_PREFIX}")
  endif()


elseif(WIN32)
  # # Warnings as errors, this is too strict!
  # if(MSVC)
  #   string(APPEND CMAKE_CXX_FLAGS " /WX")
  # endif()

  list(APPEND INC_SYS
    ${WINTAB_INC}
  )

  list(APPEND SRC
    intern/GHOST_ContextD3D.cc
    intern/GHOST_DropTargetWin32.cc
    intern/GHOST_SystemWin32.cc
    intern/GHOST_TrackpadWin32.cc
    intern/GHOST_WindowWin32.cc
    intern/GHOST_Wintab.cc

    intern/GHOST_ContextD3D.hh
    intern/GHOST_DropTargetWin32.hh
    intern/GHOST_SystemWin32.hh
    intern/GHOST_TaskbarWin32.hh
    intern/GHOST_TrackpadWin32.hh
    intern/GHOST_WindowWin32.hh
    intern/GHOST_Wintab.hh
  )

  list(APPEND SRC
    intern/GHOST_ContextWGL.cc

    intern/GHOST_ContextWGL.hh
  )

  if(WITH_INPUT_IME)
    list(APPEND SRC
      intern/GHOST_ImeWin32.cc

      intern/GHOST_ImeWin32.hh
    )
  endif()

  if(WITH_INPUT_NDOF)
    list(APPEND SRC
      intern/GHOST_NDOFManagerWin32.cc

      intern/GHOST_NDOFManagerWin32.hh
    )
  endif()
endif()

if(UNIX AND NOT APPLE)
  if(WITH_OPENGL_BACKEND)
    list(APPEND SRC
      intern/GHOST_ContextEGL.cc

      intern/GHOST_ContextEGL.hh
    )
  endif()
endif()

if(APPLE)
  if(WITH_METAL_BACKEND)
    list(APPEND SRC
      intern/GHOST_ContextCGL.mm

      intern/GHOST_ContextCGL.hh
    )
  endif()
endif()

if(APPLE)
  list(APPEND SRC

=== intern/openvdb/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
)

set(INC_SYS
)

set(SRC
  openvdb_capi.h
  openvdb_fwd.hh
)

set(LIB
  PRIVATE bf::intern::guardedalloc
)

if(WITH_OPENVDB)
  add_definitions(-DWITH_OPENVDB ${OPENVDB_DEFINITIONS})

  list(APPEND INC_SYS
    ${OPENVDB_INCLUDE_DIRS}
  )

  list(APPEND SRC
    openvdb_capi.cc
  )

  list(APPEND LIB
    ${OPENVDB_LIBRARIES}
  )
endif()

blender_add_lib(bf_intern_openvdb "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

=== intern/cycles/bvh/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2022 Blender Foundation
#
# SPDX-License-Identifier: Apache-2.0

set(INC
  ..
)

set(INC_SYS
)

set(SRC
  bvh.cpp
  bvh2.cpp
  binning.cpp
  build.cpp
  embree.cpp
  hiprt.cpp
  multi.cpp
  node.cpp
  optix.cpp
  sort.cpp
  split.cpp
  unaligned.cpp
)

set(SRC_METAL
  metal.mm
)

if(WITH_CYCLES_DEVICE_METAL)
  list(APPEND SRC
    ${SRC_METAL}
  )
  add_definitions(-DWITH_METAL)
endif()

set(SRC_HEADERS
  bvh.h
  bvh2.h
  binning.h
  build.h
  embree.h
  hiprt.h
  multi.h
  node.h
  optix.h
  params.h
  sort.h
  split.h
  unaligned.h
  metal.h
)

set(LIB
  cycles_scene
  cycles_util
)

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

if(WITH_CYCLES_EMBREE)
  list(APPEND LIB
    ${EMBREE_LIBRARIES}
  )
  if(EMBREE_SYCL_SUPPORT)
    list(APPEND LIB
      ${SYCL_LIBRARIES}
    )
  endif()
endif()

cycles_add_library(cycles_bvh "${LIB}" ${SRC} ${SRC_HEADERS})

=== source/blender/blendthumb/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

# -----------------------------------------------------------------------------
# Shared Thumbnail Extraction Logic

include_directories(
  ../blenlib
  ../blenloader_core
  ../makesdna
  ../../../intern/guardedalloc
)

include_directories(
  SYSTEM
  ${ZLIB_INCLUDE_DIRS}
)

set(SRC
  src/blendthumb.hh
  src/blendthumb_extract.cc
  src/blendthumb_png.cc
)

if(WITH_BUILDINFO)
  list(APPEND SRC
    "$<TARGET_OBJECTS:buildinfoobj>"
  )
endif()

if(WIN32)
  # -----------------------------------------------------------------------------
  # Build `BlendThumb.dll`

  set(SRC_WIN32
    src/blendthumb_win32.cc
    src/blendthumb_win32.def
    src/blendthumb_win32.rc
    src/blendthumb_win32_dll.cc
  )

  add_definitions(-DNOMINMAX)

  add_library(BlendThumb SHARED ${SRC} ${SRC_WIN32})

  setup_platform_linker_flags(BlendThumb)
  setup_platform_linker_libs(BlendThumb)

  target_link_libraries(BlendThumb PRIVATE bf_blenlib bf_blenloader_core dbghelp.lib Version.lib Comctl32.lib)
  # `blenlib` drags in a whole bunch of dependencies on shared libraries, none of which are used
  # by `blenthumb`, but will cause load issues since the debug linker will not eliminate them.
  # Link with /OPT:ref to force elimination of those unused dependencies this is already
  # enabled by default on the release mode flags.
  set_target_properties(BlendThumb PROPERTIES LINK_FLAGS "/OPT:ref")
  set_target_properties(BlendThumb PROPERTIES LINK_FLAGS_DEBUG "/NODEFAULTLIB:msvcrt")
  set_target_properties(BlendThumb PROPERTIES VS_GLOBAL_VcpkgEnabled "false")

elseif(APPLE)
  # -----------------------------------------------------------------------------
  # Build `blender-thumbnailer.appex` app extension.
  set(SRC_APPEX
    src/thumbnail_provider.h
    src/thumbnail_provider.mm
  )

  add_executable(blender-thumbnailer MACOSX_BUNDLE ${SRC} ${SRC_APPEX})
  setup_platform_linker_flags(blender-thumbnailer)
  setup_platform_linker_libs(blender-thumbnailer)
  target_link_libraries(blender-thumbnailer
    bf_blenlib
    bf_blenloader_core
    # Avoid linker error about undefined _main symbol.
    "-e _NSExtensionMain"
    "-framework QuickLookThumbnailing"
  )
  # The RPATH here points to the main Blender Resources/lib directory.
  # Avoid duplicating the large `dylibs` (~300MB).
  set_target_properties(blender-thumbnailer PROPERTIES
    INSTALL_RPATH "@loader_path/../../../../Resources/lib"
    # Prevent Xcode from overwriting the signature.
    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ""
  )
  # CMake needs the target defined in the same file as add_custom_command.
  # It needs to be code-signed (ad-hoc in this case)
  # even on developer machine to generate thumbnails.
  # Command taken from XCode build process.
  add_custom_command(
    TARGET blender-thumbnailer POST_BUILD
    COMMAND codesign --deep --force --sign -
      --entitlements "${CMAKE_SOURCE_DIR}/release/darwin/thumbnailer_entitlements.plist"
      --timestamp=none $<TARGET_BUNDLE_DIR:blender-thumbnailer>
  )
elseif(UNIX)
  # -----------------------------------------------------------------------------
  # Build `blender-thumbnailer` executable

  set(SRC_CMD
    src/blender_thumbnailer.cc
  )

  add_executable(blender-thumbnailer ${SRC} ${SRC_CMD})
  setup_platform_linker_flags(blender-thumbnailer)
  setup_platform_linker_libs(blender-thumbnailer)
  target_link_libraries(blender-thumbnailer PRIVATE bf_blenlib bf_blenloader_core)
  if(DEFINED PTHREADS_LIBRARIES)
    target_link_libraries(blender-thumbnailer PRIVATE ${PTHREADS_LIBRARIES})
  endif()
endif()

=== source/blender/imbuf/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

add_subdirectory(movie)
add_subdirectory(opencolorio)

set(INC
  PUBLIC .
  ./movie
  ../makesrna
  ../../../intern/memutil
)

set(INC_SYS
  ${JPEG_INCLUDE_DIR}
  ${ZLIB_INCLUDE_DIRS}
  ${OPENIMAGEIO_INCLUDE_DIRS}
)

set(SRC
  intern/allocimbuf.cc
  intern/colormanagement.cc
  intern/colormanagement_inline.h
  intern/conversion.cc
  intern/filetype.cc
  intern/filter.cc
  intern/format_bmp.cc
  intern/format_dds.cc
  intern/format_hdr.cc
  intern/format_iris.cc
  intern/format_jpeg.cc
  intern/format_png.cc
  intern/format_psd.cc
  intern/format_svg.cc
  intern/format_targa.cc
  intern/format_tiff.cc
  intern/imageprocess.cc
  intern/interp.cc
  intern/metadata.cc
  intern/module.cc
  intern/moviecache.cc
  intern/readimage.cc
  intern/rectop.cc
  intern/rotate.cc
  intern/scaling.cc
  intern/stereoimbuf.cc
  intern/thumbs.cc
  intern/thumbs_blend.cc
  intern/thumbs_font.cc
  intern/transform.cc
  intern/util.cc
  intern/util_gpu.cc
  intern/writeimage.cc

  IMB_colormanagement.hh
  IMB_imbuf.hh
  IMB_imbuf_enums.h
  IMB_imbuf_types.hh
  IMB_interp.hh
  IMB_metadata.hh
  IMB_moviecache.hh
  IMB_openexr.hh
  IMB_thumbs.hh
  intern/IMB_allocimbuf.hh
  intern/IMB_colormanagement_intern.hh
  intern/IMB_filetype.hh
  intern/IMB_filter.hh
  intern/imbuf.hh
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::dna
  PRIVATE bf::gpu
  bf_imbuf_openimageio
  PRIVATE bf::intern::atomic
  PRIVATE bf::intern::guardedalloc
  bf_intern_memutil
  PRIVATE bf::imbuf::opencolorio
  PRIVATE bf::extern::nanosvg

  ${JPEG_LIBRARIES}
  PRIVATE bf::sequencer
)

if(WITH_IMAGE_OPENEXR)
  list(APPEND LIB
    bf_imbuf_openexr
  )
  add_definitions(-DWITH_IMAGE_OPENEXR)
else()
  list(APPEND SRC
    intern/openexr/openexr_stub.cpp
  )
endif()

# OpenImageIO headers include `Imath` headers when there is no SSE support for
# matrix operations. This depends on the specific architecture and compiler
# flags, most reliable is to always include the `Imath` headers if we have them.
if(DEFINED IMATH_INCLUDE_DIRS)
  list(APPEND INC_SYS
    ${IMATH_INCLUDE_DIRS}
  )
endif()

if(WITH_IMAGE_OPENJPEG)
  list(APPEND INC_SYS
    ${OPENJPEG_INCLUDE_DIRS}
  )
  list(APPEND SRC
    intern/format_jp2.cc
  )
  list(APPEND LIB
    ${OPENJPEG_LIBRARIES}
  )

  add_definitions(-DWITH_IMAGE_OPENJPEG ${OPENJPEG_DEFINES})
endif()

if(WITH_IMAGE_CINEON)
  list(APPEND SRC
    intern/format_dpx.cc
  )
  list(APPEND LIB
    bf_imbuf_cineon
  )
  add_definitions(-DWITH_IMAGE_CINEON)
endif()

if(WITH_IMAGE_WEBP)
  list(APPEND SRC
    intern/format_webp.cc
  )
  list(APPEND INC_SYS
    ${WEBP_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${WEBP_LIBRARIES}
  )
  add_definitions(-DWITH_IMAGE_WEBP)
endif()

if(WIN32)
  list(APPEND INC
    ../../../intern/utfconv
  )
endif()

if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

# no need to compile object files for inline headers.
set_source_files_properties(
  intern/colormanagement_inline.cc
  PROPERTIES HEADER_FILE_ONLY TRUE
)

blender_add_lib(bf_imbuf "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_library(bf::imbuf ALIAS bf_imbuf)

if(WITH_GTESTS)
  set(TEST_SRC
    tests/IMB_scaling_test.cc
    tests/IMB_transform_test.cc
  )
  blender_add_test_suite_lib(imbuf "${TEST_SRC}" "${INC}" "${INC_SYS}" "${LIB}")
  add_subdirectory(tests/performance)
endif()

=== source/blender/io/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2020 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later


add_subdirectory(common)
add_subdirectory(csv)

if(WITH_IO_WAVEFRONT_OBJ)
  add_subdirectory(wavefront_obj)
endif()

if(WITH_IO_PLY)
  add_subdirectory(ply)
endif()

if(WITH_IO_STL)
  add_subdirectory(stl)
endif()

if(WITH_IO_GREASE_PENCIL)
  add_subdirectory(grease_pencil)
endif()

if(WITH_IO_FBX)
  add_subdirectory(fbx)
endif()

if(WITH_ALEMBIC)
  add_subdirectory(alembic)
endif()

if(WITH_OPENCOLLADA)
  add_subdirectory(collada)
endif()

if(WITH_USD)
  add_subdirectory(usd)
endif()

=== intern/cycles/kernel/osl/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2022 Blender Foundation
#
# SPDX-License-Identifier: Apache-2.0

set(INC
  ../..
)

set(INC_SYS

)

set(SRC
  closures.cpp
  globals.cpp
  services.cpp
)

set(HEADER_SRC
  closures_setup.h
  closures_template.h
  compat.h
  globals.h
  osl.h
  services.h
  services_shared.h
  types.h
)

set(LIB
  cycles_scene

  ${OSL_LIBRARIES}
  ${OPENIMAGEIO_LIBRARIES}
  ${PUGIXML_LIBRARIES}
)

if(APPLE)
  # Disable allocation warning on macOS prior to 10.14: the OSLRenderServices
  # contains member which is 64 bytes aligned (cache inside of OIIO's
  # unordered_map_concurrent). This is not something what the SDK supports, but
  # since we take care of allocations ourselves is OK to ignore the
  # diagnostic message.
  string(APPEND CMAKE_CXX_FLAGS " -faligned-allocation")
endif()

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

cycles_add_library(cycles_kernel_osl "${LIB}" ${SRC} ${HEADER_SRC})

=== source/blender/editors/asset/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
  ../include
  ../../gpu
  ../../imbuf
  ../../makesrna
  # dna_type_offsets.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../makesdna/intern
  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  intern/asset_catalog.cc
  intern/asset_filter.cc
  intern/asset_handle.cc
  intern/asset_import.cc
  intern/asset_indexer.cc
  intern/asset_library_reference_enum.cc
  intern/asset_library_utils.cc
  intern/asset_list.cc
  intern/asset_mark_clear.cc
  intern/asset_menu_utils.cc
  intern/asset_ops.cc
  intern/asset_shelf.cc
  intern/asset_shelf_asset_view.cc
  intern/asset_shelf_catalog_selector.cc
  intern/asset_shelf_popover.cc
  intern/asset_shelf_regiondata.cc
  intern/asset_shelf_settings.cc
  intern/asset_temp_id_consumer.cc
  intern/asset_type.cc
  intern/asset_ui_utils.cc

  ED_asset_catalog.hh
  ED_asset_filter.hh
  ED_asset_handle.hh
  ED_asset_import.hh
  ED_asset_indexer.hh
  ED_asset_library.hh
  ED_asset_list.hh
  ED_asset_mark_clear.hh
  ED_asset_shelf.hh
  ED_asset_temp_id_consumer.hh
  ED_asset_type.hh
  intern/asset_library_reference.hh
  intern/asset_shelf.hh
)

set(LIB
  PRIVATE bf::asset_system
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::blentranslation
  PRIVATE bf::dna
  PRIVATE bf::intern::clog
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::windowmanager
)

blender_add_lib(bf_editor_asset "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

# RNA_prototypes.hh
add_dependencies(bf_editor_asset bf_rna)

=== source/blender/editors/space_spreadsheet/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  ../include
  ../../makesrna

  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  space_spreadsheet.cc
  spreadsheet_column.cc
  spreadsheet_data_source.cc
  spreadsheet_data_source_geometry.cc
  spreadsheet_dataset_draw.cc
  spreadsheet_draw.cc
  spreadsheet_layout.cc
  spreadsheet_ops.cc
  spreadsheet_panels.cc
  spreadsheet_row_filter.cc
  spreadsheet_row_filter_ui.cc
  spreadsheet_table.cc

  spreadsheet_column.hh
  spreadsheet_column_values.hh
  spreadsheet_data_source.hh
  spreadsheet_data_source_geometry.hh
  spreadsheet_dataset_draw.hh
  spreadsheet_draw.hh
  spreadsheet_intern.hh
  spreadsheet_layout.hh
  spreadsheet_row_filter.hh
  spreadsheet_row_filter_ui.hh
  spreadsheet_table.hh
)

set(LIB
  PRIVATE bf::blenfont
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::blentranslation
  PRIVATE bf::bmesh
  PRIVATE bf::depsgraph
  PRIVATE bf::dna
  PRIVATE bf::extern::fmtlib
  PRIVATE bf::functions
  PRIVATE bf::gpu
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::nodes
  PRIVATE bf::windowmanager
)

if(WITH_OPENVDB)
  list(APPEND INC
    ../../../../intern/openvdb
  )
  list(APPEND INC_SYS
    ${OPENVDB_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${OPENVDB_LIBRARIES}
  )
  add_definitions(-DWITH_OPENVDB ${OPENVDB_DEFINITIONS})
endif()

blender_add_lib(bf_editor_space_spreadsheet "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

# RNA_prototypes.hh dna_type_offsets.h
add_dependencies(bf_editor_space_spreadsheet bf_rna)

=== source/blender/gpu/glsl_preprocess/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later


# -----------------------------------------------------------------------------
# Build `glsl_preprocess` executable.
set(SRC
  glsl_preprocess.cc

  glsl_preprocess.hh
)

if(WITH_GPU_SHADER_ASSERT)
  add_definitions(-DWITH_GPU_SHADER_ASSERT)
endif()

# `SRC_DNA_INC` is defined in the parent directory.
add_executable(glsl_preprocess ${SRC})
optimize_debug_target(glsl_preprocess)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# To build with Qt-Creator:
# 1. Launch Qt-Creator with the env (set from cmd.exe):
# set "MINGW_PREFIX=C:/msys64/mingw64"
# set "ACLOCAL_PATH=%MINGW_PREFIX%/share/aclocal:/usr/share/aclocal"
# set "PKG_CONFIG_PATH=%MINGW_PREFIX%/lib/pkgconfig"
# set "PATH=%MINGW_PREFIX%/bin;%PATH%"
# 2. Specify the following as the CMake arguments:
# -DMINGW_LIBS=%MINGW_PREFIX% -DCMAKE_BUILD_TYPE=Debug -DWITH_SYSTEM_GLEW=ON -DWITH_SYSTEM_OPENJPEG=ON -DWITH_INSTALL_PORTABLE=OFF -DWITH_OPENCOLLADA=ON -DWITH_GAMEENGINE=ON -DWITH_RAYOPTIMIZATION=ON -DWITH_JACK=OFF -DWITH_PLAYER=ON -DWITH_CODEC_FFMPEG=ON -DWITH_CODEC_SNDFILE=ON -DWITH_CYCLES=ON -DWITH_CYCLES_CUDA_BINARIES=OFF -DWITH_CYCLES_OSL=ON -DWITH_FFTW3=ON -DWITH_MOD_OCEANSIM=ON -DPYTHON_VERSION=3.7 -DPYTHON_LIBPATH=%MINGW_PREFIX%/lib -DPYTHON_LIBRARY="python3.6m" -DPYTHON_INCLUDE_DIRS=/msys64/mingw64/include/python3.6m -DWITH_PYTHON_INSTALL=OFF -DWITH_PYTHON_INSTALL_NUMPY=OFF -DPYTHON_NUMPY_PATH=%MINGW_PREFIX%/lib/python3.6/site-packages -DCYCLES_OSL=%MINGW_PREFIX% -DWITH_IMAGE_REDCODE=ON -DWITH_OPENMP=ON -DWITH_LLVM=ON -DLLVM_STATIC=ON

_realname=blender
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.5.2
pkgrel=3
pkgdesc="A fully integrated 3D graphics creation suite (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.blender.org"
msys2_repository_url="https://projects.blender.org/blender/blender"
msys2_references=(
  'archlinux: blender'
  'cpe: cpe:/a:blender:blender'
)
license=('spdx:GPL-2.0-or-later')
# build conflict with "${MINGW_PACKAGE_PREFIX}-glog"
depends=("${MINGW_PACKAGE_PREFIX}-alembic"
         "${MINGW_PACKAGE_PREFIX}-audaspace"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         #"${MINGW_PACKAGE_PREFIX}-bullet-dp"
         #"${MINGW_PACKAGE_PREFIX}-draco" It builds an internal library
         "${MINGW_PACKAGE_PREFIX}-embree"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         #"${MINGW_PACKAGE_PREFIX}-gflags"
         #"${MINGW_PACKAGE_PREFIX}-glog"
         "${MINGW_PACKAGE_PREFIX}-glslang"
         "${MINGW_PACKAGE_PREFIX}-imath"
         #"${MINGW_PACKAGE_PREFIX}-jemalloc"
         "${MINGW_PACKAGE_PREFIX}-libepoxy"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsndfile"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-lzo2"
         "${MINGW_PACKAGE_PREFIX}-manifold"
         #"${MINGW_PACKAGE_PREFIX}-materialx"
         #"${MINGW_PACKAGE_PREFIX}-usd"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openal"
         "${MINGW_PACKAGE_PREFIX}-opencollada"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-openimagedenoise"
         "${MINGW_PACKAGE_PREFIX}-openimageio"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-openpgl"
         "${MINGW_PACKAGE_PREFIX}-openshadinglanguage"
         "${MINGW_PACKAGE_PREFIX}-opensubdiv"
         "${MINGW_PACKAGE_PREFIX}-openvdb"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-potrace"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-SDL2"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-wintab-sdk"
             $([[ "$CARCH" == "aarch64" ]] && echo "${MINGW_PACKAGE_PREFIX}-sse2neon"))
install=blender-${MSYSTEM}.install
source=(https://download.blender.org/source/${_realname}-${pkgver}.tar.xz
        platform_win32_mingw64.cmake
        comctl_v6.exe.manifest
        0001-mingw-buildsystem.patch
        0002-fix-mingw-w64-definitions.patch
        0003-disable-static_assert_align-on-mingw.patch
        0004-fix-rad2-conflict.patch
        0005-fix-WINTAB_PRINTF-on-mingw.patch
        0006-mingw-DEBUG-avoid-too-many-sections.patch
        0008-mingw-use-X11-like-path-layout.patch
        0009-include-missing-headers.patch
        0010-conflict-near-far-macroses.patch
        0011-no-TIME_UTC-on-msvcrt.patch
        0013-force-draco.patch
        0014-fix-find-numpy-2.patch
        0015-mingw-python-like-msvc.patch
        0016-mingw-windres.patch
        0019-fix-casts.patch
        0020-blendthumb-build.patch
        0022-find-llvm-convert-paths.patch
        0023-link-errors.patch
        0024-openvdb-shared.patch
        0025-callback-function-prototype-fix.patch
        0028-use-std-namespace.patch
        0029-display-driver-build.patch
        0035-Enable-SSE2NEON-on-Windows-ARM.patch
        0039-no-WRL-on-mingw-w64.patch
        0050-fix-vulkan-import-lib-lookup.patch
        https://github.com/blender/blender/commit/f5f30131131025a24be93eced7d04f9d96cf5cbf.patch)
sha256sums=('ff225337b6695631b82008e94a45f0b53711d2d52497b86063d3c86880627d1f'
            'e6e5460c67ed2101004c64a8ca1cfcf2828880ea98c97f8f9f220b96e143fc25'
            '233b56fc38fe0aac714b0cfacdc8250dd64c1984d1a6785b9898a2d2c8a015ed'
            'f7081e3d7c9ae40481db8fecae2fd111898305c9a5ef05b31c6131ef8642849c'
            '2d898e81118771405fc6ae1a7f7fd75c58398c6b7a195b9cd0be0f01ba281ff3'
            'f82e9be14a1f683c3a4d6d198d7bb552e83637098dfd2a88341461347daec919'
            '2794fd231f35627681273d793895b9d66fb6546b7b5003fd6ee85d86e87b90ae'
            'af467653b9a4d3dfee8abf07e8bf23b9759ec205709dabd8735005bd263ce3c7'
            '6b86a93dfcace5a1dfb0bdc8de6b0a6318af206a738947d039bce2607ae07f7a'
            '0ec9942a62feeeca43a3cd78ac0473165bc4d43bb28cbe46faf0f574a05bf366'
            '76ef7c97a373b07b89bd16d183965dd8fae4ecfcd160d3d8b62f08f58c0a81d0'
            '9e2541912f106171be109aaf11c5406d9ddd62b6d930628aaa0982ceb8216a66'
            '84fdb7b1c4f408aff199172cbb09460ac60443156bc78fc3eaf3ba90e6fb500e'
            'e9e26a1c9b540fbdd7f63e83c0bbdf71c08a0e68f7ceb57fcb322113a97c9a62'
            'ae2270a6db620a93655255a6a5400b1857b5a5d29e2999cd7649b54f63c0d5fc'
            'fd2230e71f8deb6a3252c5ea439803bdb6abb5124d0cc2bc64dc856de7bd00cf'
            '9600e82135f63924ebcf7de84b983a2fc031acdec5a382b1a713ed6fd064de62'
            '620c06f1db232fb838f3d7fb3fdaeda862ece0782cdba517b43cb9c170f57e2b'
            'ae1daa500f50c74ffa906979ea1d41cda28b36f95d1ac0aab8e714c4a55642cb'
            'f2e166b76a9cfb2b753072cf0a45a241c84ff3f539e8c3c43d96c2679a144c81'
            '28c121996d4d652910ef8661723ee5a54e52913361c5fc1e3b5f0aaa82fe5543'
            '99fb88ff39e10273725e71aad62d12c480adc5f5c4a2c3a6181b4094d9327bae'
            '3d9903bbc99a533723e84dcb465fab9ba7b0cc3fd7cec664633cbc860de9c4d6'
            'caa7b9dd66086fe0274ce8ae55d3084e5ded2e68189c9857582c4da7b211ca33'
            '260d52ff166635145dd3b3e51ba291eba1edc01274f3385cfe89c02ea1489761'
            '3cc151106b16adf40a9d1a751519365eeaf2ebd4bacb359272cc04d5f55c61be'
            'd4a02b177c08c37551087e391237bf15ed534ec405edfe961783b8bb4cf99c6a'
            '1a5e091054edee6507e148bd697b1426a4d3234cdb6b704151e67e36b884131f'
            'c5137eea29301cf1fbc0e62ac159c8c63d4e5bb9536461c3c76ff749e7be39f6')
#options=(debug)

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  cp -f ${srcdir}/platform_win32_mingw64.cmake build_files/cmake/platform/
  
  cp -f ${srcdir}/comctl_v6.exe.manifest release/windows/icons/blender.exe.manifest
  cp -f ${srcdir}/comctl_v6.exe.manifest ./tests.exe.manifest

  apply_patch_with_msg \
    0001-mingw-buildsystem.patch \
    0002-fix-mingw-w64-definitions.patch \
    0003-disable-static_assert_align-on-mingw.patch \
    0004-fix-rad2-conflict.patch \
    0005-fix-WINTAB_PRINTF-on-mingw.patch \
    0008-mingw-use-X11-like-path-layout.patch \
    0009-include-missing-headers.patch \
    0010-conflict-near-far-macroses.patch \
    0011-no-TIME_UTC-on-msvcrt.patch \
    0013-force-draco.patch \
    0014-fix-find-numpy-2.patch \
    0015-mingw-python-like-msvc.patch \
    0016-mingw-windres.patch \
    0019-fix-casts.patch \
    0020-blendthumb-build.patch \
    0022-find-llvm-convert-paths.patch \
    0023-link-errors.patch \
    0024-openvdb-shared.patch \
    0025-callback-function-prototype-fix.patch \
    0028-use-std-namespace.patch \
    0029-display-driver-build.patch \
    0035-Enable-SSE2NEON-on-Windows-ARM.patch \
    0039-no-WRL-on-mingw-w64.patch \
    0050-fix-vulkan-import-lib-lookup.patch \
    f5f30131131025a24be93eced7d04f9d96cf5cbf.patch

  if check_option "debug" "y"; then
    apply_patch_with_msg \
      0006-mingw-DEBUG-avoid-too-many-sections.patch
  fi

  # Remove *.orig files
  find . -type f -name "*.orig" -exec rm -f {} \;
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM}  && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug" "-DWITH_CYCLES_DEBUG=ON" "-DWITH_GHOST_DEBUG=ON" "-DWITH_DRAW_DEBUG=ON")
  fi

  CXXFLAGS+=" -w"
  CFLAGS+=" -w"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
    CFLAGS+=" -Wno-unreachable-code-generic-assoc"
  fi

  if [[ $MINGW_PACKAGE_PREFIX != *-clang-* ]]; then
    CFLAGS+=" -Wno-incompatible-pointer-types"
  fi

  if [[ $CARCH == "aarch64" ]]; then
    _extra_config+=("-DSSE2NEON_ROOT_DIR=${MINGW_PREFIX}/include/sse2neon")
  fi

  export XR_OPENXR_SDK_ROOT_DIR=${MINGW_PREFIX}
  export EMBREE_ROOT_DIR=${MINGW_PREFIX}

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

  CXXFLAGS+=" -D_USE_MATH_DEFINES" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DWITH_SYSTEM_AUDASPACE=ON \
    -DWITH_SYSTEM_GFLAGS=OFF \
    -DWITH_SYSTEM_GLOG=OFF \
    -DWITH_SYSTEM_BULLET=OFF \
    -DWITH_SYSTEM_LZO=ON \
    -DWITH_SYSTEM_EIGEN3=ON \
    -DWITH_SYSTEM_FREETYPE=ON \
    -DWITH_INSTALL_PORTABLE=OFF \
    -DWITH_NANOVDB=OFF \
    -DWITH_OPENCOLORIO=ON \
    -DWITH_CYCLES=ON \
    -DWITH_CYCLES_STANDALONE=ON \
    -DWITH_CYCLES_STANDALONE_GUI=ON \
    -DWITH_CYCLES_CUDA_BINARIES=OFF \
    -DWITH_CYCLES_OSL=ON \
    -DWITH_VULKAN_BACKEND=ON \
    -DWITH_MEM_JEMALLOC=OFF \
    -DWITH_MOD_OCEANSIM=ON \
    -DPYTHON_VERSION=${_pyver} \
    -DPYTHON_LIBPATH=${MINGW_PREFIX}/lib \
    -DPYTHON_LIBRARY=${MINGW_PREFIX}/lib/libpython${_pyver}.dll.a \
    -DPYTHON_INCLUDE_DIR=${MINGW_PREFIX}/include/python${_pyver} \
    -DWITH_PYTHON_INSTALL=OFF \
    -DWITH_PYTHON_INSTALL_NUMPY=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  cp -r bin "${pkgdir}"${MINGW_PREFIX}/
  rm "${pkgdir}"${MINGW_PREFIX}/bin/msgfmt.exe

  # Manually install draco bindings
  #_pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")
  #mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/python${_pyver}"/
